// u_32_process_html_download
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_32_process_html_download;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Vcl.OleCtrls, SHDocVw;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    display_html_text_: TButton;
    extract_and_display_links_: TButton;
    Panel4: TPanel;
    Splitter2: TSplitter;
    url_edit_: TEdit;
    WebBrowser1: TWebBrowser;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure display_html_text_Click(Sender: TObject);
    procedure display_in_twebbrowser_Click(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure extract_and_display_links_Click(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure handle_thread_did_terminate(p_c_thread: tObject);
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple
      , u_c_standard_synchronize
      , u_c_anonymous_synchronize
      , u_c_download_thread_2
      , u_process_download
      ;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.handle_thread_did_terminate(p_c_thread: tObject);
      begin
        display('did terminate');
      end; // handle_thread_did_terminate

    procedure TForm1.display_html_text_Click(Sender: TObject);
      begin
        display('> display_page');
        with c_download_thread.create_download_thread(
            url_edit_.Text,
            handle_thread_did_terminate,
            procedure (p_c_response_content_stream: TStringStream)
              begin
                display(' '+ p_c_response_content_stream.DataString);
              end
            ) do;
        display('< display_page');
      end; // display_html_text_Click

    procedure TForm1.extract_and_display_links_Click(Sender: TObject);
      begin
        with c_download_thread.create_download_thread(
            url_edit_.Text,
            handle_thread_did_terminate,
            procedure (p_c_response_content_stream: TStringStream)
              begin
                extract_content_links(p_c_response_content_stream.DataString,
                  procedure (const p_link_url: string)
                    begin
                      Memo1.Lines.Add(p_link_url);
                    end
                );
              end
            ) do;
      end; // extract_and_display_links_Click





    var g_c_stream: tStream;

    procedure TForm1.display_in_twebbrowser_Click(Sender: TObject);
      begin
        with c_download_thread.create_download_thread(
            url_edit_.Text,
            handle_thread_did_terminate,
            procedure (p_c_response_content_stream: TStringStream)
              begin
                display('copy_string');
                g_c_stream:= tStringStream.Create(p_c_response_content_stream.DataString);

(*
                display_in_webbrowser(g_c_stream,
                    WebBrowser1);
*)
              end
            ) do;

      end; //

    procedure TForm1.cClick(Sender: TObject);
      begin
        display((g_c_stream as tStringStream).DataString);
        display_in_webbrowser(g_c_stream, WebBrowser1);
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

