// u_c_zzz
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_download_thread_2;
  interface
    uses Classes, SysUtils, StrUtils, IdHttp;

    type t_ap_process_donwload= reference to procedure (p_c_response_content_stream: TStringStream);

         c_download_thread=
             class(TThread)
               private
                 m_url: string;
                 m_ap_process_donwload: t_ap_process_donwload;
               protected
                 procedure Execute; override;
               public
                 constructor create_download_thread(const p_url: string;
                     p_handle_did_terminate: tNotifyEvent;
                     p_ap_process_donwload: t_ap_process_donwload);
             end; // c_download_thread

    procedure download_and_process(const p_url: string;
        p_handle_did_terminate: tNotifyEvent;
        p_ap_process_donwload: t_ap_process_donwload);

  implementation
    uses Dialogs, u_display_simple;

    // -- global

    procedure download_and_process(const p_url: string;
        p_handle_did_terminate: tNotifyEvent;
        p_ap_process_donwload: t_ap_process_donwload);
      begin
        c_download_thread.create_download_thread(p_url,
            p_handle_did_terminate, p_ap_process_donwload);
      end; // download_and_process

    // -- c_download_thread

    constructor c_download_thread.create_download_thread(const p_url: string;
        p_handle_did_terminate: tNotifyEvent;
        p_ap_process_donwload: t_ap_process_donwload);
      begin
        m_url:= p_url;
        m_ap_process_donwload:= p_ap_process_donwload;
        OnTerminate:= p_handle_did_terminate;

        FreeOnTerminate:= True;

        inherited Create(False);
      end; // create_download_thread

    procedure c_download_thread.Execute;
      var l_c_id_http: TIdHttp;
          l_c_response_content_stream: TStringStream;
      begin
        Synchronize(procedure
          begin
            display('> url '+ m_url);
          end);

        l_c_id_http:= TIdHTTP.Create(nil);
        l_c_response_content_stream:= TStringStream.Create;
        try
          l_c_id_http.Get(m_url, l_c_response_content_stream);
          l_c_response_content_stream.Position:= 0;
          m_ap_process_donwload(l_c_response_content_stream);
        finally
          l_c_response_content_stream.Free;
        end;

        l_c_id_http.Free;
        Synchronize(procedure
          begin
            display('< url '+ m_url);
          end);
      end; // Execute

    end.
