unit u_process_download;
  interface
    uses Classes, SHDocVw;

    type t_ap_process_found_item= reference to procedure (const strLink: string);

    procedure extract_content_links(p_content_string: string;
        p_ap_process_found_item: t_ap_process_found_item);

    procedure display_in_webbrowser(p_c_content_stream: tStream;
      p_c_webbrowser: tWebBrowser);

  implementation
    uses SysUtils, StrUtils, ActiveX, Forms, Dialogs, u_display_simple;

    procedure extract_content_links(p_content_string: string;
        p_ap_process_found_item: t_ap_process_found_item);
      // -- extract all "<A HREF="http://xxx">
      var l_href_start_index, l_href_end_index: Integer;
          l_link_url: string;
      begin
        display('> extract_content_links');
        p_content_string:= LowerCase(p_content_string);
        l_href_start_index:= 1;
        repeat
          l_href_start_index:= PosEx('href="http', p_content_string, l_href_start_index);

          if l_href_start_index<> 0
            then begin
                l_href_start_index:= l_href_start_index+ 6;
                l_href_end_index:= PosEx('"', p_content_string, l_href_start_index);
                l_link_url:= Copy(p_content_string, l_href_start_index,
                    l_href_end_index- l_href_start_index);

                // -- display or whatever this link
                p_ap_process_found_item(l_link_url);

                l_href_start_index:= l_href_end_index+ 1;
              end;
        until l_href_start_index= 0;
        display('< extract_content_links');
      end; // extract_content_links

    procedure display_in_webbrowser(p_c_content_stream: tStream; p_c_webbrowser: tWebBrowser);
      var l_i_persiste_stream_init: IPersistStreamInit;
      begin
        p_c_webbrowser.Navigate('about:blank');
        while p_c_webbrowser.ReadyState <> Shdocvw.READYSTATE_COMPLETE do
          Application.ProcessMessages;
        display('ok_ready');

        if p_c_webbrowser.Document.QueryInterface(IPersistStreamInit, l_i_persiste_stream_init)= S_OK
          then begin
              if l_i_persiste_stream_init.InitNew= S_OK
                then begin
                    display('do_display');
                    l_i_persiste_stream_init.Load(TStreamAdapter.Create(p_c_content_stream));
                  end;
          end;
      end; // display_in_webbrowser
end.
